<?php

	/*----------------------------------------------------------------------------------------
 	乐智大转盘 DISCUZ 插件接口  2014-8-15  乐智软件 www.lezhi99.com  版权所有
	----------------------------------------------------------------------------------------*/

	//禁止直接访问
	if(!defined('IN_DISCUZ') || !defined('IN_ADMINCP')) {exit('Access Denied');}
	//导入函数库
	require_once DISCUZ_ROOT.'/source/plugin/lezhi99_lottery/include/common.php';
	//默认为list
	$view = !LZ::input('get.view') ? 'list' : LZ::input('get.view');
	//输出配置列表
	if($view=='list'){
		$LB = LZ::label();
		//技巧提示
		showtips(LZ::lang('prize_tip'));
		//创建表单
		showformheader(LZ::getAdminUrl('prize','save','form'));
			//创建表格
			showtableheader(LZ::lang('prize_table_title'));
				//表头
				showsubtitle(array(
					LZ::lang('prize_table_head1'),
					LZ::lang('prize_table_head2'),
					LZ::lang('prize_table_head3'),
					LZ::lang('prize_table_head4'),
					LZ::lang('prize_table_head5'),
				));
				//获取API奖品配置
				$list = LZ::getLotteryConfig('prize');
				//循环创建每一行
				$tdWidth = array('width="60"','width="70"','width="160"','width="150"','');
				foreach ($list as $k=>$v){
					//设置显示项
					$display=array('extcredits'=>'none','medal'=>'none','magic'=>'none','num'=>'none','numNo'=>'none');
					if($v['type']=='extcredits'){ $display['num']=''; }else{ $display['numNo']=''; }
					$display[$v['type']]='';
					//输出行
					showtablerow('',$tdWidth,array(
						'<input class="checkbox" type="checkbox" name="delete['.$k.']">',
						'<input type="text" style="display:none;" name="id[]" value="'.$v['id'].'"><input type="text" style="width:30px;" class="txt" name="order[]" value="'.$v['order'].'">',
						$LB->prizeTypeSelect('name="type[]" onchange="setsel(this.value,'.$k.');"',$v['type']),
						$LB->extcreditsSelect('id="prize_extcredits_'.$k.'" name="extcredits[]" style="display:'.$display['extcredits'].';"',$v['prize']).
						$LB->medalSelect('id="prize_medal_'.$k.'" name="medal[]" style="display:'.$display['medal'].';"',$v['prize']).
						$LB->magicSelect('id="prize_magic_'.$k.'" name="magic[]" style="display:'.$display['magic'].';"',$v['prize']),
						'<input type="text" style="width:30px;display:'.$display['num'].';" class="txt" id="num_'.$k.'" name="num[]" value="'.$v['num'].'"><span id="num_no_'.$k.'" style="width:30px;display:'.$display['numNo'].';">--</span>',
					));
				}
				//添加新配置
				$temArr = end($list);
				showtablerow('',$tdWidth,array(
					'<span style="color:#ff0000;">'.LZ::lang('prize_add_text').'</span>',
					'<input type="text" style="width:30px;" class="txt" name="order_new" value="'.($temArr['order']+10).'">',
					$LB->prizeTypeSelect('name="type_new" onchange="setsel(this.value,\'new\');"',null,LZ::lang('prize_select_tip')),
					$LB->extcreditsSelect('id="prize_extcredits_new" name="prize_extcredits_new" style="display:none;"').
					$LB->medalSelect('id="prize_medal_new" name="prize_medal_new" style="display:none;"').
					$LB->magicSelect('id="prize_magic_new" name="prize_magic_new" style="display:none;"').
					'<span id="prize_none_new">--</span>',
					'<input type="text" style="width:30px;display:none;" class="txt" name="num_new" id="num_new" value="0"><span id="num_no_new">--</span>',
				));
				//添加新奖品
				showtablerow('',$tdWidth,array(
					"<input type=\"checkbox\" name=\"chkall\" id=\"chkall\" class=\"checkbox\" onclick=\"checkAll('prefix',this.form,'delete')\"> <label for=\"chkall\">".LZ::lang('prize_del_text')."</label>",
					'<input type="submit" class="btn" value="'.LZ::lang('prize_submit_text').'" />',
				));
			showtablefooter();	//表格结束
		showformfooter();	//表单结束
		//输出JS代码
		echo '
			<script>
				function setsel(val,ids){
					if(val==""){val="none";}
					document.getElementById("prize_extcredits_"+ids).style.display="none";
					document.getElementById("prize_medal_"+ids).style.display="none";
					document.getElementById("prize_magic_"+ids).style.display="none";
					if(ids=="new"){document.getElementById("prize_none_"+ids).style.display="none";}
					document.getElementById("prize_"+val+"_"+ids).style.display="";
					if(val=="extcredits"){
						document.getElementById("num_"+ids).style.display="";
						document.getElementById("num_no_"+ids).style.display="none";
					}else{
						document.getElementById("num_"+ids).style.display="none";
						document.getElementById("num_no_"+ids).style.display="";
					}
				}
			</script>
		';
	}
	//保存配置修改
	if($view=='save' && submitcheck('formhash')){
		//获得GET参数
		$deletes = LZ::input('get.delete');
		$ids	 = LZ::input('get.id','int');
		$orders  = LZ::input('get.order','int');
		$types	 = LZ::input('get.type');
		$prizes  = LZ::input('get.prize','int');
		$nums	 = LZ::input('get.num','int');
		//获取修改
		foreach($types as $k=>$v){
			//var_dump($prizes);
			//exit();
			//排除勾选删除的条目
			if(!$deletes[$k]){
				$tempPrizes = LZ::input("get.$v",'int');
				$list[] = array(
					'id'	=> $ids[$k],
					'order'	=> $orders[$k],
					'type'	=> $types[$k],
					'prize'	=> $prizes[$k],
					'prize'	=> $tempPrizes[$k],
					'num'	=> $nums[$k],
				);
			}
		}
		//获取新增（检查 奖项名称、奖品类型、奖品设置）
		if(LZ::input('get.type_new')!='' && LZ::input('get.prize_'.LZ::input('get.type_new').'_new','int')!=''){

			$list[] = array(
				'id'	=> LZ::getSeeds(),	//获取不重复种子
				'order'	=> LZ::input('get.order_new','int'),
				'type'	=> LZ::input('get.type_new'),
				'prize'	=> LZ::input('get.prize_'.LZ::input('get.type_new').'_new','int'),
				'num'	=> LZ::input('get.num_new','int'),
			);
		}
		//保存记录
		LZ::saveLotteryConfig('prize',$list);
		//同步数据
		$pingState = LZ::ping('update_prize_config');
		if(!is_array($pingState)){ $errorTip='<br/><br/><b>'.LZ::lang('prize_ping_failure').$pingState.'。</b><br/>'; }
		//输出提示
		cpmsg(LZ::lang('prize_save_tip').$errorTip,LZ::getAdminUrl('prize','list','cpmsg'));
	}
?>