<?php

	/*----------------------------------------------------------------------------------------
 	乐智大转盘 DISCUZ 插件接口  2014-8-15  乐智软件 www.lezhi99.com  版权所有
	----------------------------------------------------------------------------------------*/

	//禁止直接访问
	if(!defined('IN_DISCUZ')) {exit('Access Denied');}
	//获得缓存变量
	global $_G,$LZ_CODING;
	//导入函数库
	require_once DISCUZ_ROOT.'/source/plugin/lezhi99_lottery/include/common.php';
	//获取相关变量
	$apiKey = LZ::getCache('api_key');			// API通讯密匙
	$api	= LZ::input('get.api');				// 获得请求的API名称
	$reTime	= LZ::input('get.time','int');		// 获得请求的发起时间
	//提高安全性，重要API进行时间有效验证
	if(in_array($api, array(
		'get_user_key',		//获取用户登录票据
		'verify_user_key',	//核验用户登录票据
		'user_exchange',	//用户抽奖机会兑换
		'prize_exchange',	//API奖品兑换
		))){
		//API请求有效时间为10分钟，这需要求服务器同本地时间误差在3分钟内。
		if((time()-$reTime)>60*10){
			exit(json_encode(array('state'=>'error','tip'=>'The request has expired')));
		}
	}
    //---------------------------------------------------校验通讯密匙-开始
    $tempArr = LZ::input('get.');				//获得所有get参数
    unset($tempArr['key']);                     //去掉key值
    unset($tempArr['id']);                      //去掉id值
	sort($tempArr,SORT_STRING);					//按字符串升序排序
	$key = md5($apiKey.implode('', $tempArr));	//拼接并进行MD5加密
    //校验密匙，密匙错误则输出 key error 信息
    if($key!=LZ::input('get.key')){ exit(json_encode(array('state'=>'error','tip'=>'key error'))); }
    //---------------------------------------------------校验通讯密匙-结束
    //编码转换处理
    //to_current_coding()
    //开始处理每一个API
    switch ($api){
    	//通讯测试
		case 'ping':
			$return['state']='succeed';
			break;
		//输出登录窗口
		case 'login_win':
			if(LZ::input('get.mobile','int')=='1'){
				header('Location:plugin.php?id=lezhi99_lottery&view=login&mobile=1');
			}else{
				header('Location:plugin.php?id=lezhi99_lottery&view=login');
			}
			break;
		//获得用户登录票据
		case 'get_user_key':
			if($_G['uid']>0){
    			//获取需要的参数
    			$uid		 = $_G['uid'];			//用户ID
                $username    = $_G['username'];		//用户名
                $groups      = $_G['groupid'];       //用户组
    			$create_time = time();				//当前时间戳
    			//拼接并加密，生成用户票据
    			$user_key	 = md5($uid.$username.$groups.$create_time.$apiKey);
    			//写入到$return数组中
    			$return = array(
                    'uid'       	=> $uid,
                    'username'  	=> $username,
                    'groups'    	=> $groups,
                    'create_time'   => $create_time,
                    'avatar_url'	=> 'http://'.$_SERVER['HTTP_HOST']."/uc_server/avatar.php?uid=$uid",
                    'user_key'  	=> $user_key,
                );
			}else{
    			//用户未登录，写入$return数组UID为0即可。
    			$return = array('uid'=>0);
    		}
    		exit('var uInfo='.json_encode(LZ::to_utf8($return)));
			break;
		//验证登录票据，这边的过程是 get_user_key API的逆算法
		case 'verify_user_key':
    		//获得参数
    		$uid 	   		= LZ::to_current_coding(LZ::input('get.uid','int'));			//用户ID
    		$username  		= LZ::to_current_coding(LZ::input('get.username'));				//用户名
            $groups    		= LZ::to_current_coding(LZ::input('get.groups'));				//会员组
    		$create_time 	= LZ::to_current_coding(LZ::input('get.create_time','int'));	//密匙生成时间戳
    		$user_key  		= LZ::to_current_coding(LZ::input('get.user_key'));				//票据
    		//重新生成票据
    		$new_user_key = md5($uid.$username.$groups.$create_time.$apiKey);
 	    	//检查票据是否正确，正确则返回validity为1，否则返回0.
	    	if($new_user_key==$user_key){
	    		$return = array('state'=>'valid');		//票据有效
	    	}else{
	    		$return = array('state'=>'invalid');		//票据无效
    		}
    		break;
    	//用户登出
		case 'user_qiut':
			global $_G;
			foreach($_G['cookie'] as $k => $v) {
				if($k != 'widthauto') {
					dsetcookie($k);
				}
			}
			$_G['uid'] = $_G['adminid'] = 0;
			$_G['username'] = $_G['member']['password'] = '';
			exit("var logoutState='succeed';");
		//获得积分配置
		case 'get_extcredits_config':
			$list = LZ::getLotteryConfig('extcredits');
			foreach($list as $k=>$v){
				//$return['extcredits'.$v['extcredits']] = array('name'=>LZ::getExtcreditsName($v['extcredits']),'num'=>$v['price']);
				$return[] = array('id'=>'extcredits'.$v['extcredits'],'name'=>LZ::getExtcreditsName($v['extcredits']),'num'=>$v['price']);
			}
			if(!$return){$return=array();}
			break;
    	//获取用户剩余积分
    	case 'get_user_extcredits':
			//获得参数
			$uid = LZ::input('get.uid','int');//用户ID
			if($uid>0){
				$extcreditsList = LZ::getLotteryConfig('extcredits');
				foreach ($extcreditsList as $v) { $field[] = 'extcredits'.$v['extcredits']; }
				if($field){
					$return = DB::fetch_first('SELECT '. implode(',',$field).' FROM '.DB::table('common_member_count').' where uid='.$uid);
					if(!$return){
						$return['state'] = 'error';
						$return['tip']   = LZ::lang('api_no_user');
					}
				}else{
					$return=array();
				}
			}else{
				$return['state'] = 'error';
				$return['tip']   = LZ::lang('api_uid_error');
			}
			break;
		//兑换抽奖次数，扣除用户积分
		case 'user_exchange':
			//获得参数
			$uid    = LZ::input('get.uid','int');			//用户ID
			$type   = (int)substr(LZ::input('get.type'),10,1);		//积分类型
			$num    = LZ::input('get.num','int');					//兑换次数
			//获取用户剩余积分（若获取失败则输出错误）
			$surplus = LZ::getMemberExtcredits($uid,$type);
			if(!$surplus){
				$return['state'] = 'error';
				$return['tip'] = LZ::lang('api_system_error');
				break;
			}
			//获取积分兑换比率
			$extcreditsConfig = LZ::getLotteryConfig('extcredits');
			foreach ($extcreditsConfig as $v) {
				if($v['extcredits']==$type){ $price=$v['price']; break;}
			}
			if(!$price){ $return['tip'] = LZ::lang('api_exchange_style_error'); break; }
			//检查积分是否足够
			$countNum = $price*$num;
			if($surplus<$countNum){
				$return['state'] = 'error';
				$return['tip'] = LZ::lang('api_exchange_deficiency',array('num'=>$num));
				break;
			}
			//扣除积分，返回成功提示
			updatemembercount($uid,array("extcredits$type"=>$countNum*-1),false,'',0,'',LZ::lang('api_exchange_log_title'),LZ::lang('api_exchange_log_note',array('num'=>$num)));
			$return['state'] = 'succeed';
			break;
		//获得奖品配置
		case 'get_prize_config':
			$list = LZ::getLotteryConfig('prize');
			foreach($list as $v){
				$id = $v['id'];
				//获得奖品名称
				switch($v['type']) {
					case 'extcredits':
						$ename = LZ::getExtcreditsName($v['prize']);
						$name = $v['num'].$ename;
						$describe = LZ::lang('api_prize_ext_describe',array('ename'=>$ename));
						break;
					case 'medal':
						$data = DB::fetch_first('SELECT name,description FROM '.DB::table('forum_medal').' where medalid='.(int)$v['prize']);
						$name = $data['name'];
						$describe = LZ::lang('api_prize_medal_describe',array('medalName'=>$data['name'],'medalDescribe'=>$data['description']));
						break;
					case 'magic':
						$data = DB::fetch_first('SELECT name,description FROM '.DB::table('common_magic').' where magicid='.(int)$v['prize']);
						$name = $data['name'];
						$describe = LZ::lang('api_prize_magic_describe',array('magicName'=>$data['name'],'magicDescribe'=>$data['description']));
						break;
					default:
						$name = LZ::lang('api_prize_unknown_name');
						$describe = LZ::lang('api_prize_unknown_describe');
						break;
				}
				$return[] = array('id'=>$id,'name'=>$name,'describe'=>$describe);
			}
			if(!$return){$return=array();}
			break;
    	//获得用户组配置
    	case 'get_groups_config':
    		$list = LZ::getList('SELECT groupid,grouptitle FROM '.DB::table('common_usergroup'));
    		foreach($list as $v){
    			$return[] = array('id'=>$v['groupid'],'name'=>$v['grouptitle']);
    		}
			if(!$return){$return=array();}
			break;
		//兑换API奖品
		case 'prize_exchange':
			//获得参数
			$uid     = LZ::input('get.uid','int');
			$prizeId = LZ::input('get.prizeId','int');
			//获得奖品配置
			$list = LZ::getLotteryConfig('prize');
			foreach($list as $k=>$v){
				if($v['id']==$prizeId){ $pInfo = $v; break; }
			}
			//奖品不存在，则输出错误提示。
			if(!$pInfo){
				$return['state'] = 'error';
				$return['tip'] = LZ::lang('api_prize_nonentity');
				break;
			}
			//发放奖品
			switch($pInfo['type']) {
				//积分奖品
				case 'extcredits':
					//奖励用户积分
					$prize_name = $pInfo['num'].LZ::getExtcreditsName($pInfo['prize']);
					updatemembercount($uid,array(
						'extcredits'.$pInfo['prize']=>$pInfo['num'])
						,false,'',0,'',
						LZ::lang('api_pexchange_extcredits_title'),
						LZ::lang('api_pexchange_extcredits_log',array('prizeName'=>$prize_name))
					);
					$return['state'] = 'succeed';
					$return['tip'] = LZ::lang('api_pexchange_extcredits_tip');
					break;
				//勋章奖品
				case 'medal':
					//先获取勋章信息（勋章缓存中的勋章信息未包含有效期，所以这边从数据库读取）
					$mInfo = DB::fetch_first('SELECT medalid,expiration,name FROM '.DB::table('forum_medal').' where medalid='.$pInfo['prize']);
					if(!$mInfo){
						$return['state'] = 'error';
						$return['tip'] = LZ::lang('api_pexchange_medal_error');
						break;
					}
					//拼接勋章信息字符串，格式为“勋章ID|到期时间”，无期限的则为“勋章ID”。
					if($mInfo['expiration']=='0'){
						$medalStr = $mInfo['medalid'];
					}else{
						$medalStr = $mInfo['medalid'].'|'.(($mInfo['expiration']*86400)+time());
					}
					//获取用户的勋章信息
					$tmArray = DB::fetch_first('SELECT medals FROM '.DB::table('common_member_field_forum').' where uid='.$uid);
					$UserMedal = $tmArray['medals'];
					//判断用户是否已经拥有此勋章，拥有的话更新勋章到期时间，否则添加勋章
					foreach($tempArray = explode("\t", $UserMedal) as $key => $v) {
						list($medalid,$medalexpiration) = explode('|', $v);
						if($medalid==$mInfo['medalid']){
							$have=1;
							//已存在则刷新勋章到期时间
							if($mInfo['expiration']!='0'){
								$UserMedal = str_replace($medalexpiration,(($mInfo['expiration']*86400)+time()),$UserMedal);
							}
						}
					}
					//如果勋章不存在，则增加
					if($have!=1){
						$UserMedal=='' ? $UserMedal=$medalStr : $UserMedal.="\t".$medalStr;
						$tip=LZ::lang('api_pexchange_medal_succeed');
						//添加勋章日志
						if($mInfo['expiration']!='0'){
							$Dexpiration = $mInfo['expiration']*86400+time();
							$Dmedalstatus = 1;
						}else{
							$Dexpiration = 0;
							$Dmedalstatus = 1;
						}
						DB::insert('forum_medallog', array(
							'uid' => $uid,
							'medalid' => $mInfo['medalid'],
							'type' => 0,
							'dateline' => $_G['timestamp'],
							'expiration' => $Dexpiration,
							'status' => $Dmedalstatus,
						));
						$mcontent = LZ::lang('api_pexchange_medal_succeed_tip',array('medalName'=>$mInfo['name']));
					}else{
						$tip=LZ::lang('api_pexchange_medal_have');
					}
					//更新用户勋章信息
					DB::query('UPDATE '.DB::table('common_member_field_forum')." SET medals='".$UserMedal."' WHERE uid=".$uid);
					//记录奖品名称并输出提示
					$prize_name = $mInfo['name'].LZ::lang('api_pexchange_medal_name');
					$return['state'] = 'succeed';
					$return['tip'] = $tip;
					break;
				//道具奖品
				case 'magic':
					//加载道具的缓存
					loadcache('magics');
					$prize_name = LZ::lang('api_pexchange_magics_name').' '.$_G['cache']['magics'][$pInfo['prize']]['name'];
					//获取条数，检查是否存在
					$mCount =  DB::result_first('SELECT count(*) FROM '.DB::table('common_member_magic').' where magicid='.$pInfo['prize'].' and uid='.$uid);
					if($mCount>0){ //存在则添加数量
						DB::query('UPDATE '.DB::table('common_member_magic').' SET num=num+1 where magicid='.$pInfo['prize'].' and uid='.$uid);
					}else{ //不存在则插入记录
						$datas= array('uid'=>$uid,'magicid'=>$pInfo['prize'],'num'=>1);
						DB::insert('common_member_magic',$datas);
					}
					$return['state'] = 'succeed';
					$return['tip'] = LZ::lang('api_pexchange_magics_succeed');
					$mcontent = LZ::lang('api_pexchange_magics_succeed_tip',array('magicsName'=>$prize_name));
					break;
				//不存在的奖品
				default:
					$prize_name = LZ::lang('api_pexchange_unknown_name');
					$return['state'] = 'error';
					$return['tip'] = LZ::lang('api_pexchange_unknown_tip');
					break;
			}
			//写入奖品发放日志
			DB::insert(LZ::table('log'),array(
				'uid' => $uid,
				'prize_name' => $prize_name,
				'post_time' => time(),
			));
			//发送提醒（若提醒内容为空则不发送）
			$mcontent!='' && notification_add($uid,'system',$mcontent,array(),1);
			break;
		//用户中奖通知（自动回帖）
		case 'win_notice':
			$reply_tid = LZ::getCache('reply_tid');
			$reply_content = LZ::getCache('reply_content');
			if($reply_tid>0){
				//获得用户信息
	    		$uid 		= LZ::to_current_coding(LZ::input('get.uid','int'));				//用户ID
	    		$prize_name = LZ::to_current_coding(LZ::input('get.prize_name'));				//奖品名称
				//获得回帖主体信息
				$thread = DB::fetch_first("SELECT * FROM ".DB::table('forum_thread')." WHERE tid=$reply_tid");
				if(!$thread['fid']){ break; }
				$uInfo  = DB::fetch_first("SELECT username FROM ".DB::table('common_member')." WHERE uid=$uid");
				$username = $uInfo['username'];
				$message = str_replace('[prizeName]', $prize_name, $reply_content);
				//插入回帖
				require_once libfile('function/post');
				require_once libfile('function/forum');
				$pid = insertpost(array(
					'fid'		=> $thread['fid'],
					'tid'		=> $reply_tid,
					'first'		=> '0'
					,'author'	=> $username,
					'authorid'	=> $uid,
					'subject'	=> '',
					'dateline'	=> $_G['timestamp'],
					'message'	=> $message,
					'useip'		=> $_G['clientip'],
					'invisible'	=> '0',
					'anonymous'	=> '0',
					'usesig'	=> '0',
					'htmlon'	=> '0',
					'bbcodeoff'	=> '0',
					'smileyoff'	=> '0',
					'parseurloff'	=> '0',
					'attachment'	=> '0',
				));

				//更新主体最后回帖信息
				DB::query('UPDATE '.DB::table('forum_thread')." SET lastposter='$username', lastpost='$_G[timestamp]', replies=replies+1 WHERE tid='$reply_tid' AND fid='$thread[fid]'", 'UNBUFFERED');
				//更新板块最后回帖信息和增加帖子数等
				$lastpost = "$thread[tid]\t".addslashes($thread['subject'])."\t$_G[timestamp]\t$username";
				DB::query("UPDATE ".DB::table('forum_forum')." SET lastpost='$lastpost', posts=posts+1, todayposts=todayposts+1 WHERE fid='$thread[fid]'", 'UNBUFFERED');
				//更新板块帖子数
				updatepostcredits('+', $uid, 'reply', $thread['fid']);
			}
			break;
		//iframe模式跨域自适应宽度代理页
		case 'iframe_agency':
			exit('
				<script>
					var LZiframe = parent.parent.document.getElementById("LZiframe");
					hashStr = window.location.hash;
					LZiframe.style.height = hashStr.split("#")[1]+"px";
				</script>
			');
			break;
    }
    //输出$return信息
    exit(json_encode(LZ::to_utf8($return)));
?>